(***********************************************************************
This file was generated automatically by the Mathematica front end.
It contains Initialization cells from a Notebook file, which typically
will have the same name as this file except ending in ".nb" instead of
".m".

This file is intended to be loaded into the Mathematica kernel using
the package loading commands Get or Needs.  Doing so is equivalent to
using the Evaluate Initialization Cells menu command in the front end.

DO NOT EDIT THIS FILE.  This entire file is regenerated automatically 
each time the parent Notebook file is saved in the Mathematica front end.
Any changes you make to this file will be overwritten.
***********************************************************************)











createChromosomes[howMany_Integer, maxStates_Integer] :=
Apply[pop,
  chromo[q[undef],p[#]]& /@
  makeRandomAutomataPopulation[howMany,maxStates]]

Options[createChromosomes]={MaxStates\[Rule]10};













Mutation[chromoPop_pop, opts___] :=
Module[{},

  pop[ Mutation[Selection[chromoPop, opts]//First, opts] ]
]













Mutation[chromo[qual_q, prog_p], opts___] :=
Module[{},

  chromo[q[undef],
         p[FSAMutation[prog//First]]
  ]
]

















Copy[chromoPop_pop, opts___] :=
Module[{},

  pop[ Selection[chromoPop, opts]//First ]
]







randomSelect[s_List] := 
  s[[Random[Integer,{1,Length[s]}]]]



randomSubset[l_List,n_Integer,excludes_List:{}]:=
  NestWhile[
    Complement[Union[#,{randomSelect[l]}],excludes]&,{},(Length[#]<n)&]







randomSelectMultiple[s_List,n_Integer:1,opts___] :=
Module[{m,i},
  m=Map[s[[#]]&,i=Take[RandomPermutation[Length[s]],n]];
  
  If[ReturnIndices /. {opts} /. Options[randomSelectMultiple],
    {m,i},
    m
  ]
]

Options[randomSelectMultiple] = {ReturnIndices -> False};





selectFitProp[fitnesses_, opts___] :=
Module[{cumFits, fits, r, m},

  fits = 
  If[Negative[m = Min[fitnesses]], fitnesses -m, fitnesses];
  
  cumFits = FoldList[Plus, 0, fits] // Rest;
  
  r = Random[] Last[cumFits];
  
  Position[cumFits, _?(# >= r &), {1}, 1][[1,1]]
]



selectRankBased[fitnesses_, opts___] :=
Module[{fitsAndIndsSorted, index},
  
  fitsAndIndsSorted = 
    Sort[MapIndexed[{#1,First[#2]}&,fitnesses]];
  
  index = selectFitProp[Range[Length[fitnesses]]];
  
  fitsAndIndsSorted[[index]]//Last
]



selectElite[fitnesses_, opts___] :=
Module[{bestCount, fitsAndIndsSorted},

  bestCount = Elite /. {opts} /. Options[selectElite];
  
  fitsAndIndsSorted = 
    Reverse[Sort[MapIndexed[{#1,First[#2]}&,fitnesses]]];
    
  selectRandom[
    Last /@ 
    If[IntegerQ[bestCount],
      Take[fitsAndIndsSorted, bestCount],
      Take[fitsAndIndsSorted, 
        Max[1, Floor[bestCount Length[fitnesses]]]]
    ]
  ]
]

Options[selectElite] =
{
  Elite -> 1
};



selectBest[fitnesses_, opts___] :=
Module[{bestCount, fitsAndIndsSorted},

  bestCount = Best /. {opts} /. Options[selectBest];
  
  fitsAndIndsSorted = 
    Reverse[Sort[MapIndexed[{#1,First[#2]}&,fitnesses]]];
    
  Last /@ 
  If[IntegerQ[bestCount],
    Take[fitsAndIndsSorted, bestCount],
    Take[fitsAndIndsSorted, 
      Max[1, Floor[bestCount Length[fitnesses]]]]
  ]
]



Options[selectBest] =
{
  Best -> 1
};



selectTournament[fitnesses_,opts___]:=
  
  Module[{howManyCompetitors,fitsAndInds,competitors,wins,fit,
      scoresAndIndsSorted},
    
    howManyCompetitors=(TournamentCompetitors/.{opts}/.Options[
            selectTournament]);
    
    fitsAndInds=MapIndexed[{#1,First[#2]}&,fitnesses];
    
    competitors=
      Map[randomSubset[fitsAndInds,howManyCompetitors,{#}]&,fitsAndInds];
    
    wins=MapThread[(fit=First[#1];
            Count[Map[(fit>First[#])&,#2],True])&,{fitsAndInds,competitors}];
    
    scoresAndIndsSorted=Map[Last,Sort[MapIndexed[{#1,First[#2]}&,wins]]];
    
    Sort[Take[
        scoresAndIndsSorted,-Best /. {opts}/.Options[selectTournament]]]
    ]

Options[selectTournament]=
    {
      TournamentCompetitors\[Rule]5,
      Best\[Rule]1
      };









Selection[population_pop,howMany_Integer:1,
  opts___] :=
  
Module[{},
  
  Switch[
    SelectionMode /. {opts} /. Options[Selection],
    
    BEST,
      Take[
        population // Sort // Reverse,
        howMany
      ],
      
    RANDOM,
      pop @@
      Table[
        population[[Random[Integer,
                           {1,Length[population]}]]],
        {howMany}
      ],
      
    FITPROP,
      Table[
        population[[
          selectFitProp[extractQuals[population],opts]
        ]],
        {howMany}],
        
    RANKBASED,
      Table[
        population[[
          selectRankBased[extractQuals[population],opts]
        ]],
        {howMany}],
        
    ELITE,
      Table[
        population[[
          selectElite[extractQuals[population],opts,
            Elite -> 1.
          ]
        ]],
        {howMany}],
    TOURNAMENT,
        population[[
          selectTournament[extractQuals[population],opts,
            Best -> howMany
          ]
        ]]
  ]
]











Options[Selection] =
{
  SelectionMode -> FITPROP
};



extractQuals[population_pop] := 
  List @@ Map[First[First[#]]&,population]



























Evaluation[chromo[quality_q,prog_p,x___],
  opts___] :=

Module[{g},

  g = EvaluationFunction /. {opts} /. Options[Evaluation];
  
  chromo[q[g[prog//First]//N],prog,x]
]

Options[Evaluation] =
{
  EvaluationFunction :> Depth
};





Evolution[
  EP[m_?IntegerQ,  (* parents          *)
     s_?AtomQ,     (* PLUS or COMMA    *)
     l_?IntegerQ,  (* children         *)
     g_?IntegerQ,  (* generations      *)
     opts___] i_:1 (* options *) (* independent runs *)
] := 
Module[{initialParents,evalFct,parents,children,
        selPool, selectOperator, 
        opsAndProbs, gen},
        
  Print["EP experiment ..."];
  
  (* Define an operator selection function *)
  
  opsAndProbs = Operators /.{opts} /. Options[Evolution];
  Print["opsAndProbs: ",opsAndProbs];
  
  selectOperator := First[Transpose[opsAndProbs]][[
    selectFitProp[Last[Transpose[opsAndProbs]]]]];
  
  (* Generate m initial individuals *)
  
  If[(initialParents = (InitialPopulation /. {opts} 
      /. Options[Evolution])) === {},
      
    initialParents = 
      createChromosomes[m,
        MaxStates /. {opts} /. Options[createChromosomes]
      ]
  ];
  
  
  (* Get the evaluation function *)
  
  evalFct = EvaluationFunction
            /. {opts} /. Options[Evaluation];
       
  (* Evaluate initial individuals *)
  
  Print["Generation ",gen = 0];
  
  initialParents =
    Map[
      Evaluation[#,EvaluationFunction :> evalFct]&,
      initialParents
  ];
  (*Print["Population: ",initialParents//ColumnForm];*)
  
  (*showPopulation[initialParents,
  DisplayWidth /.{opts} /. Options[showPopulation]];*)
  
  (*plotFitnesses[initialParents,opts];*)
  
  (* Iterate for i independent runs *)
  
  Table[
  
    (* Iterate for g generations *)
    
    NestList[
      ( Print["Generation ",++gen];
        parents = #;
        
        prettyPrintFitnesses[parents];
        
        children = pop[];
        
        While[Length[children] < l,

          children = children ~Join~
            selectOperator[parents, opts]
        ];
        
        children = 
          Map[Evaluation[#,EvaluationFunction :> evalFct,opts]&, Take[children,l]];
        
        selPool = 
          Switch[s,
            PLUS,
              Join[parents,children],
            COMMA,
              children
          ];
          
        selPool = 
        Join[selPool,
          Selection[parents, 1, SelectionMode -> BEST]];
  
        PruneFSAPop[Selection[selPool,m,
          SelectionMode -> TOURNAMENT,opts],opts]
        
      ) &,
      initialParents,
      g
    
    ], (* end nesting *)
    
    {i} (* independent runs *)
  ] 
]

Options[Evolution] = 
{
  InitialPopulation -> {},
  SelectionMode -> FITPROP,
  
  Operators -> {{Recombination, .5},
                {Mutation -> .25},
                {Copy -> .25}
               },
  
  ExprMaxDepth -> 2,
  ExprPatterns -> {},
  ExprAtoms -> {}
};





showPopulation[popFSA_pop,partitionSize_Integer,opts___]:=Module[{},
    showAutomataPop[Cases[popFSA//Sort//Reverse,_Automaton,Infinity],
      Cases[popFSA//Sort//Reverse,_q,Infinity],partitionSize,opts]
    ]

Options[showPopulation]=Options[showMinPopulation]={DisplayWidth\[Rule]5};



showMinPopulation[popFSA_pop,partitionSize_Integer,opts___]:=Module[{},
    showMinAutomataPop[Cases[popFSA//Sort//Reverse,_Automaton,Infinity],
      Cases[popFSA//Sort//Reverse,_q,Infinity],partitionSize,opts]
    ]



showMinPopulationStructure[popFSA_pop,partitionSize_Integer,opts___]:=
  Module[{},
    showMinAutomataStructurePop[
      Cases[popFSA//Sort//Reverse,_Automaton,Infinity],
      Cases[popFSA//Sort//Reverse,_q,Infinity],partitionSize,opts]
    ]



prettyPrintFitnesses[ep_pop]:=
  Module[{},
    
    fitnesses=Sort[Cases[ep,_q,Infinity]/.{q[x_]\[RuleDelayed]x}];
    Print["Fitnesses: ",Sort[fitnesses]];
    ]



Needs["Statistics`DescriptiveStatistics`"]

Needs["Graphics`FilledPlot`"]



plotFitnesses[es_pop,opts___] :=
Module[{fitnesses},

  fitnesses =
    Sort[Cases[es,_q,Infinity] /. {q[x_] :> x}];
  Print["Fitnesses: ",fitnesses];
  ListFilledPlot[Map[Max[#]&,fitnesses],
                 Map[Mean[#]&,fitnesses],
    PlotRange -> All,
    AxesLabel -> {"Gen.","Fit."},
    PlotLabel -> FontForm["Best and Mean Fitness\n" <>
      (PlotTitle /. {opts} /. Options[plotFitnesses]),
                   {"Helvetica-Bold",10}],
                   DisplayFunction->$DisplayFunction
  ]
]







Options[plotFitnesses] =
{
  PlotTitle -> " "
};











saveEPData[gp_,file_String:""] := 
Module[{fileName},

  If[file === "",
    fileName = StringReplace["EP-Data." <> ToString[Unique[EP]],
                 "$" -> ""],
    fileName = file
  ];
  
  Put[gp,fileName];
  
  fileName
]

